; Source created with Parsic Version 3.x

; at              : 12/08/02 12.41.33


; Project File    : c:\PROGRA~1\PARSIC\LUCISC.PIC

; Project Version : 1.0.10

; Created         : 11/08/02 20.19.00

; Last change     : 12/08/02 12.41.29

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ON & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

S0	= 12	; located in Bank 0, 1
OS1_FD	= 13	; located in Bank 0, 1
SYS_WSAV	= 14	; located in Bank 0, 1
SYS_SSAV	= 15	; located in Bank 0, 1
TR1	= 16	; located in Bank 0, 1
TR1_HI	= 17	; located in Bank 0, 1
ZV1	= 18	; located in Bank 0, 1
ZV1_FD	= 19	; located in Bank 0, 1
S1	= 20	; located in Bank 0, 1
RAM	= 21	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11111110'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S1,2
	GOTO LABEL_RS1_RESET
	BTFSS S0,0
	GOTO LABEL_RS1_ENDE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,0	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; One Shot -> OS1
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,0
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF S0,0
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 161
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,2
	GOTO LABEL_TR1_CLR
	BSF S0,2
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,2
LABEL_TR1_ENDE

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTB,0
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,2
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,1
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF S0,1
LABEL_LG1_ENDE
;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 300
	SUBWF ZV1,W	; F - W -> W

LABEL_IF1_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,4
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,4

LABEL_IF1_EXIT
;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 600
	SUBWF ZV1,W	; F - W -> W

LABEL_IF2_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S0,5
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S0,5

LABEL_IF2_EXIT
;***************************************************
; Vergleich -> IF3
;***************************************************

	MOVLW 900
	SUBWF ZV1,W	; F - W -> W

LABEL_IF3_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF3_FALSE

LABEL_IF3_TRUE
	BSF S0,6
	GOTO LABEL_IF3_EXIT

LABEL_IF3_FALSE
	BCF S0,6

LABEL_IF3_EXIT
;***************************************************
; Zhler -> ZV1
;***************************************************

	BTFSS S1,2	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BTFSS S0,1
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S0,3	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCF ZV1,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	DECF ZV1,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BTFSC S0,1
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; GND
;***************************************************

	BCF S0,3	; immer Low

;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS S0,4
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,1
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S1,0
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF S1,0
LABEL_LG2_ENDE
;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S0,5
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,2
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S0,7
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF S0,7
LABEL_LG3_ENDE
;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSS S0,6
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,3
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF S1,1
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF S1,1
LABEL_LG4_ENDE
;***************************************************
; ODER - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BTFSC S1,0
	GOTO LABEL_LG5_TRUE
LABEL_LG5_2
	BTFSC S0,7
	GOTO LABEL_LG5_TRUE
LABEL_LG5_3
	BTFSC S1,1
	GOTO LABEL_LG5_TRUE

LABEL_LG5_FALSE
	BCF S1,2
	GOTO LABEL_LG5_ENDE
LABEL_LG5_TRUE
	BSF S1,2
LABEL_LG5_ENDE
;****************************************

	GOTO MAIN


	END

